// ClientSubjectDlg.cpp : implementation file
//

#include "stdafx.h"
#include <objbase.h>
#include "ClientSubject.h"
#include "ClientSubjectDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientSubjectDlg dialog

CClientSubjectDlg::CClientSubjectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClientSubjectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClientSubjectDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CClientSubjectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClientSubjectDlg)
	DDX_Control(pDX, IDC_STATIC_NOTIFIEDDATA, m_staticnotifieddata);
	DDX_Control(pDX, IDC_EDIT_OBJ2SUBSCRIBE, m_editobj2subscribe);
	DDX_Control(pDX, IDC_EDIT1, m_edit1);
	DDX_Control(pDX, IDC_EDIT_DATANOTIF, m_edit_datanotif);
	DDX_Control(pDX, IDC_STATIC_GETCOUNTSUBSCRIBERS, m_static_CountSubscribers);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClientSubjectDlg, CDialog)
	//{{AFX_MSG_MAP(CClientSubjectDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_NOTIFY, OnButtonNotify)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_GETCOUNTSUBSCRIBERS, OnButtonGetcountsubscribers)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTONSUBSCRIBE, OnButtonsubscribe)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClientSubjectDlg message handlers

BOOL CClientSubjectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here



	// Component ..
	CString strserverName="";
	HRESULT hr;
	COSERVERINFO serverinfo;
	COSERVERINFO *pServerInfo=NULL;
	serverinfo.dwReserved1=0;
	serverinfo.dwReserved2=0;
	serverinfo.pwszName=strserverName.AllocSysString();
	serverinfo.pAuthInfo=NULL;
	if( strserverName.IsEmpty() )
		pServerInfo = NULL;
	else
		pServerInfo = &serverinfo;

	MULTI_QI qi= {&IID_IGenericObserver,NULL,0};

	hr = CoCreateInstanceEx(	CLSID_GenericObserver,NULL,
								CLSCTX_ALL, /*CLSCTX_LOCAL_SERVER|CLSCTX_REMOTE_SERVER,*/
								pServerInfo,1,&qi);
	
	if( SUCCEEDED(qi.hr) )
	{
		DWORD dwIdSubject;
		m_pSubject = (IGenericObserver*) qi.pItf;
		
	}
	else
	{
		m_pSubject = NULL;
		AfxMessageBox("Impossible de creer l'objet");
	}

	
	
	// Create the outgoing obj
	//
	if( m_pSubject )
	{
		CComObject<CGenericObserverNotifier> * pNotifier;
		CComObject<CGenericObserverNotifier>::CreateInstance(&pNotifier);
			
		pNotifier->SetNotificationRout(this);

		DWORD dwCookie = 99;
		hr = AtlAdvise(m_pSubject,pNotifier->GetUnknown(),
							IID_IGenericObserverNotification,&dwCookie);
	}

	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClientSubjectDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CClientSubjectDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CClientSubjectDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CClientSubjectDlg::OnButtonNotify() 
{
	// TODO: Add your control notification handler code here
	CString s ;
	m_edit_datanotif.GetWindowText(s);
	if( m_pSubject )
		m_pSubject->Notify(s.GetLength(),(unsigned char*)s.GetBuffer(0));
		//m_pSubject->Notify(0,(unsigned char*)0);
}

void CClientSubjectDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	// TODO: Add your message handler code here
	if( m_pSubject )
		m_pSubject->Release();
}

void CClientSubjectDlg::OnButtonGetcountsubscribers() 
{
	// TODO: Add your control notification handler code here
	LONG lCount = 0;
	if( m_pSubject )
	{
		m_pSubject->GetCountSubscribers(&lCount);
	}
	CString s;
	s.Format("%d",lCount);
	m_static_CountSubscribers.SetWindowText(s);
}

void CClientSubjectDlg::OnButton1() 
{
	// TODO: Add your control notification handler code here
	CString s;
	m_edit1.GetWindowText(s);
	m_pSubject->SetName( CComBSTR(s) );
}

void CClientSubjectDlg::OnButtonsubscribe() 
{
	// TODO: Add your control notification handler code here
	CString s;
	m_editobj2subscribe.GetWindowText(s);
	DWORD d;
	m_pSubject->FindObjectID(CComBSTR(s),&d);
	m_pSubject->Subscribe(d);
}

void CClientSubjectDlg::OnNotifyNOTIFY(ObserverNotification* pNotification)
{
	

	CString s;
	for(int i = 0; i < pNotification->m_nSize; i++ )
		s += *(pNotification->m_pBytes+i);

	m_staticnotifieddata.SetWindowText(s);

}

void CClientSubjectDlg::OnNotifyNOTIFY_SUBJECTBROKEN(DWORD dwSubjectID)
{
	CString s;
	s.Format("Notif.:Subject %d down",dwSubjectID);
	m_staticnotifieddata.SetWindowText(s);
}
