// ClientSubjectDlg.h : header file
//

#if !defined(AFX_CLIENTSUBJECTDLG_H__1B086EB6_551C_11D2_A942_62789E000000__INCLUDED_)
#define AFX_CLIENTSUBJECTDLG_H__1B086EB6_551C_11D2_A942_62789E000000__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "..\Server\RNSO.H"
#include "..\RnsoClient\CGenericObserverNotifier.h"

/////////////////////////////////////////////////////////////////////////////
// CClientSubjectDlg dialog

class CClientSubjectDlg : public CDialog,public RnsoNotificationRout
{
// Construction
public:
	CClientSubjectDlg(CWnd* pParent = NULL);	// standard constructor


	IGenericObserver	* m_pSubject;

	void OnNotifyNOTIFY(ObserverNotification* pNotification);
	void OnNotifyNOTIFY_SUBJECTBROKEN(DWORD dwSubjectID);


// Dialog Data
	//{{AFX_DATA(CClientSubjectDlg)
	enum { IDD = IDD_CLIENTSUBJECT_DIALOG };
	CStatic	m_staticnotifieddata;
	CEdit	m_editobj2subscribe;
	CEdit	m_edit1;
	CEdit	m_edit_datanotif;
	CStatic	m_static_CountSubscribers;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CClientSubjectDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CClientSubjectDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonNotify();
	afx_msg void OnDestroy();
	afx_msg void OnButtonGetcountsubscribers();
	afx_msg void OnButton1();
	afx_msg void OnButtonsubscribe();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_CLIENTSUBJECTDLG_H__1B086EB6_551C_11D2_A942_62789E000000__INCLUDED_)
