// ObserverNotification.cpp: implementation of the ObserverNotification class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ObserverNotification.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ObserverNotification::ObserverNotification(DWORD dwSenderObject,byte * pBytes ,long nSize )
{
	m_nSize	= 0;
	m_pBytes=NULL;
	m_dwSenderObject=dwSenderObject;

	if( nSize > 0 )
	{
		m_pBytes = new byte[nSize];
		m_nSize	 = nSize;
		memcpy(m_pBytes,pBytes,nSize*sizeof(byte));
	}
}

ObserverNotification::~ObserverNotification()
{
	if( m_pBytes )
	{
		delete [] m_pBytes;
	}
	m_pBytes = NULL;
	m_nSize  = 0;
}
