//
// CCriticalArray.h
//

#ifndef CCriticalArray_H_
#define CCriticalArray_H_


template< class TYPE, class ARG_TYPE > class CCriticalArray : public CArray<TYPE,ARG_TYPE>
{
private:
	CCriticalSection	m_csLock;
public:
	BOOL	Lock()
	{
		return m_csLock.Lock();
	}
	BOOL	Unlock()
	{
		return m_csLock.Unlock();
	}
};

#endif
